static VALUE wrap_initializeCRoutines_C( VALUE self, VALUE tNoSNP, VALUE nPtPool, VALUE nCtPool, VALUE nExtra, VALUE lgGap );
static VALUE wrap_readSumSNPData_C( VALUE self, VALUE dataAr, VALUE index );
static VALUE wrap_setupRgChunkAndRgChromosome_C( VALUE self );
static VALUE wrap_correctErrorHM_C( VALUE self, VALUE eRate );
static VALUE wrap_loadAnnotationFile( VALUE self, VALUE dataAr, VALUE index, VALUE tNoSNP );
static VALUE wrap_readGenotypingData_C( VALUE self, VALUE idx, VALUE sjt, VALUE gt, VALUE pl );
static VALUE wrap_outputSumSNPFile_C( VALUE self, VALUE idx );
static VALUE wrap_isHMandHHSameInSelectedPt( VALUE self, VALUE idx, VALUE stListAr, VALUE md );
static VALUE wrap_rateOfRCHHInControl( VALUE self, VALUE range, VALUE stListAr, VALUE cOff );
static VALUE wrap_takeOverlap_C2( VALUE self, VALUE stEdRgArAr, VALUE equalToOrMoreThan );
static VALUE wrap_significantQuadriadRegion_C( VALUE self, VALUE stEdRgArAr, VALUE stListAr, VALUE cOffHM, VALUE cOffHH, VALUE omitComparingRHS, VALUE omitComparingRCHH );
static int compareHeteroSNP( const void *a, const void *b );
static int compare_ovlpSt( const void *a, const void *b );
static int isSignificantQuadriad( long st, long ed, long *rSt, long* rEd, int noSt, int *stNo, int cutoffHM, int cutoffHH, VALUE omitComparingRHS, VALUE omitComparingRCHH );
static int isBothInRHSAndRCHH( long index, int noSt, int* stNo );
static int isInRCHH( long index, int noSt, int* stNo );
static void insertFragmentIBD_Hetero( int pool, int noStInPool, int noStToInsert, int genM, long snpNoDis );
static void insertFragmentIBD_Homo( int pool, int noStInPool, int noStToInsert, int genM, long snpNoDis );
static VALUE wrap_saveGenotype( VALUE self );
static VALUE wrap_restoreGenotype( VALUE self );
static VALUE wrap_getPossibleRange( VALUE self, VALUE radius, VALUE snp );
static VALUE wrap_performShuffle_C( VALUE self, VALUE stNo );
static VALUE wrap_resetNoSNP( VALUE self, VALUE newValue );

/*
 *  mersenneTwister.h
 *
 *	Reference: M. Matsumoto and T. Nishimura, "Mersenne Twister: A 623-dimensionally equidistributed uniform pseudorandom number generator", ACM Trans. on Modeling and Computer Simulation Vol. 8, No. 1, January pp.3-30 (1998)
 *
 */

void	init_genrand( unsigned long s );
void init_by_array(unsigned long init_key[], int key_length);
unsigned long genrand_int32(void);
long genrand_int31(void);
double genrand_real1(void);
double genrand_real2(void);
double genrand_real3(void);
double genrand_res53(void) ;

